<template>
  <div>
    <v-row justify="center">
      <div v-if="parameterName">
        Requested parameter<br />
        <i class="primary--text">{{ parameterName }}</i>
      </div>
      <v-col cols="11" md="9">
        <v-text-field
          v-model="paramValue"
          :disabled="disabled"
          append-outer-icon="mdi-send"
          clear-icon="mdi-close-circle"
          type="number"
          autocomplete="off"
          @keydown.enter="sendParameter"
          @click:append-outer="sendParameter"
          ref="inputField"
        ></v-text-field>
        <p>{{ message }}</p>
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col cols="11" md="9"> <MessageList /> </v-col
    ></v-row>
  </div>
</template>

<script>
import { EventBus } from "@/plugins/bus.js";
import { Parameter } from "@/plugins/data_structures/Coms";
import MessageList from "./MessageList";

export default {
  name: "Coms",
  components: {
    MessageList,
  },
  data: () => ({
    currentParam: "",
    paramValue: 0,
    disabled: true,
    message: "",
  }),
  computed: {
    parameterName() {
      return this.currentParam;
    },
  },
  methods: {
    sendParameter() {
      //this.$store.dispatch("coms/edit", this.paramValue);
      this.$socket.emit("data-send", this.paramValue);
      this.disable();
    },
    enable(parameterName) {
      this.currentParam = parameterName;
      this.disabled = false;
      this.$nextTick(this.$refs.inputField.focus);
    },
    disable() {
      this.currentParam = "";
      this.disabled = true;
      this.paramValue = 0;
      this.message = "";
    },
  },
  created() {
    // Requests for user input
    this.$socket.on("data-request", (data) => {
      this.message = data.message;
      this.enable(data.name);
    });

    // Parameter with value
    this.$socket.on("parameter", (data) => {
      let msg = new Parameter(data.name, data.value);
      this.$store.dispatch("coms/addParameter", msg);
    });

    EventBus.$on("resetWidgets", () => {
      this.disable();
    });
  },
};
</script>
